#include <stdlib.h>
#include <iostream>
using namespace std;

class A
{
    struct Buffer
    {
        char *p;

        Buffer() : p(0)
        {
        }

        ~Buffer()
        {
            if (p != 0)
                delete[] p;
        }
    };

    Buffer pBuffer;             // Pointeur  libration automatique.
    int  *pData;                // Pointeur classique.

public:
    A() throw (double);
    ~A();

    static void *operator new(size_t taille)
    {
        cout << "new" << endl;
        return malloc(taille);
    }

    static void operator delete(void *p)
    {
        cout << "delete" << endl;
        free(p);
    }
};

// Constructeur susceptible de lancer une exception :
A::A() throw (double)
try : pData()
{
    cout << "Dbut du constructeur" << endl;
    pBuffer.p = new char[10];
    pData = new int[10];        // Fuite de mmoire !
    cout << "Lancement de l'exception" << endl;
    throw 2;
}
catch (int)
{
    cout << "catch du constructeur..." << endl;
    // delete[] pData;          // Illgal! L'objet est dj dtruit !
    // Conversion de l'exception en flottant :
    throw 3.14;
}

A::~A()
{
    // Libration des donnes non automatiques :
    delete[] pData;             // Jamais appel !
    cout << "A::~A()" << endl;
}

int main(void)
{
    try
    {
        A *a = new A;
    }
    catch (double d)
    {
        cout << "Ae, mme pas mal !" << endl;
    }
    return EXIT_SUCCESS;
}

